// util.h
// contains several useful template functions
// Sven Hartrumpf (C) 1004


#ifndef UTIL_H_

#define UTIL_H_



/*



DOCUMENT



template<class T> inline T max(T & a,T & b);

  Returns the maximum of the two arguments.

template<class T> inline T min(T & a,T &b);

  Returns the minimum of the two arguments.

template<class T> inline void swap(T & a,T & b);

  Swaps the contents of the two arguments.

template<class T> T ceiling_ld(T a);

  Returns ceiling(ld(a)).

*/


template<class T> inline T max(T & a,T & b) { return (a > b) ? a : b; }


template<class T> inline T min(T & a,T & b) { return (a < b) ? a : b; }


template<class T> inline void swap(T & a,T & b) { T help=a; a=b; b=help; }


template<class T> T ceiling_ld(T a)
{
  if (a == 0)
    return 0;
  else if (a == 1)
    return 1;
  else
  {
    T add = 0, n = 0;
    do
    {
      if (a & 1)
        add = 1;
      n++;
      a >>= 1;
    }
    while (a > 1);
    return n + add;
  }
}


#endif
